<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoSalario extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrvinculom     = $this->getSolicitacao()->getNrvinculom();
        $dtaltesalario  = isset($itens['DTALTESALARIO']) ? DateUtil::getDataDeString(substr($itens['DTALTESALARIO'],0,10), 'd/m/Y', true) : null;
        $nrtipoaltera   = $itens['NRTIPOALTERA']        ?? null;
        $nrtpmodalidsal = $itens['NRTPMODALIDSAL']      ?? null;
        $idtpsalario    = $itens['IDTPSALARIO']         ?? null;
        $nrocorrencia   = $itens['NROCORRENCIA']        ?? null;
        $novoVlrSalario = $itens['VRSALARIO']           ?? $itens['NOVOVALORSALARIO'] ?? null;
        
        if (!$dtaltesalario) {
            throw new \Exception("Solicitação sem data ou com data de alteração inválida. Favor reprovar e incluir uma nova solicitação.");
        }
        
        if (!$nrtipoaltera) {
            throw new \Exception("Solicitação sem tipo de alteração informado. Favor reprovar e incluir uma nova solicitação.");
        }
        
        /** @var \Teknisa\Model\Gestaopessoas\Entities\GpeAltesalario $alteSalario */
        $gpeAltesalrio = Repositories::GPE_ALTESALARIO;
        $alteSalario = new $gpeAltesalrio;
        $alteSalario->setNrorg(Utils::getParamters()->getNrorg());
        $alteSalario->setNrvinculom($nrvinculom);
        $alteSalario->setDtaltesalario($dtaltesalario);
        $alteSalario->setNrocorrencia($nrocorrencia);
        $alteSalario->setNrtipoaltera($nrtipoaltera);
        $alteSalario->setNrtpmodalidsal($nrtpmodalidsal);
        $alteSalario->setIdtpsalario($idtpsalario);
        $alteSalario->setVrsalario($novoVlrSalario);
        $alteSalario->setDtinclusao(DateUtil::getDataAtual(false));
        $alteSalario->setNrorginclusao(Utils::getParamters()->getNrorg());
        $alteSalario->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $alteSalario->setNraltesalario(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_ALTESALARIO', 1, 12, true));
        Utils::getEntityManager()->persist($alteSalario);
        Utils::getEntityManager()->flush();
    }
    
    public function rejeitar() {}
}